From c8f99618d3fd1c79b248e5471a4e99421cc09815 Mon Sep 17 00:00:00 2001
From: Dan Gastler <dgastler@gmail.com>
Date: Mon, 26 Jul 2021 11:15:01 -0400
Subject: [PATCH 1/2] Added debugging output for external abort on
 non-linefetch issue

---
 arch/arm/mm/fsr-2level.c | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

diff --git a/arch/arm/mm/fsr-2level.c b/arch/arm/mm/fsr-2level.c
index f2be951..a9f06f1 100644
--- a/arch/arm/mm/fsr-2level.c
+++ b/arch/arm/mm/fsr-2level.c
@@ -12,9 +12,9 @@
 	{ do_translation_fault,	SIGSEGV, SEGV_MAPERR,	"section translation fault"	   },
 	{ do_bad,		SIGBUS,	 0,		"external abort on linefetch"	   },
 	{ do_page_fault,	SIGSEGV, SEGV_MAPERR,	"page translation fault"	   },
-	{ do_bad,		SIGBUS,	 0,		"external abort on non-linefetch"  },
+	{ do_bad,		SIGBUS,	 0,		"external abort on non-linefetch 1"  },
 	{ do_bad,		SIGSEGV, SEGV_ACCERR,	"section domain fault"		   },
-	{ do_bad,		SIGBUS,	 0,		"external abort on non-linefetch"  },
+	{ do_bad,		SIGBUS,	 0,		"external abort on non-linefetch 2"  },
 	{ do_bad,		SIGSEGV, SEGV_ACCERR,	"page domain fault"		   },
 	{ do_bad,		SIGBUS,	 0,		"external abort on translation"	   },
 	{ do_sect_fault,	SIGSEGV, SEGV_ACCERR,	"section permission fault"	   },
@@ -52,7 +52,7 @@
 	{ do_translation_fault,	SIGSEGV, SEGV_MAPERR,	"section translation fault"	   },
 	{ do_bad,		SIGSEGV, SEGV_ACCERR,	"page access flag fault"	   },
 	{ do_page_fault,	SIGSEGV, SEGV_MAPERR,	"page translation fault"	   },
-	{ do_bad,		SIGBUS,	 0,		"external abort on non-linefetch"  },
+	{ do_bad,		SIGBUS,	 0,		"external abort on non-linefetch 3"  },
 	{ do_bad,		SIGSEGV, SEGV_ACCERR,	"section domain fault"		   },
 	{ do_bad,		SIGBUS,  0,		"unknown 10"			   },
 	{ do_bad,		SIGSEGV, SEGV_ACCERR,	"page domain fault"		   },
-- 
1.8.3.1


From fce5049537a0bf31cf27ac92404eeda47e23619f Mon Sep 17 00:00:00 2001
From: Dan Gastler <dgastler@gmail.com>
Date: Mon, 26 Jul 2021 13:39:38 -0400
Subject: [PATCH 2/2] Fix looks to be the same as previous broken fix, but
 trying

---
 arch/arm/mm/fault.c      | 28 ++++++++++++++++++++++++++++
 arch/arm/mm/fsr-2level.c |  6 +++---
 2 files changed, 31 insertions(+), 3 deletions(-)

diff --git a/arch/arm/mm/fault.c b/arch/arm/mm/fault.c
index bd0f482..5e8de92 100644
--- a/arch/arm/mm/fault.c
+++ b/arch/arm/mm/fault.c
@@ -495,6 +495,13 @@ static inline bool access_error(unsigned int fsr, struct vm_area_struct *vma)
 	return 1;
 }
 
+/*   
+ * This abort handler returns no fault, but also calls arm_notifiy_die
+ * Forward declaration here   
+ */  
+static int
+do_ignore(unsigned long addr, unsigned int fsr, struct pt_regs *regs);
+
 struct fsr_info {
 	int	(*fn)(unsigned long addr, unsigned int fsr, struct pt_regs *regs);
 	int	sig;
@@ -542,6 +549,27 @@ struct fsr_info {
 		       fsr, 0);
 }
 
+/*   
+ * This abort handler returns no fault, but also calls arm_notifiy_die
+ * forward declaration above  
+ */  
+static int
+do_ignore(unsigned long addr, unsigned int fsr, struct pt_regs *regs) 
+{    
+  //Taken from do_DataAbort() 
+  const struct fsr_info *inf = fsr_info + fsr_fs(fsr); 
+  arm_notify_die("", regs, inf->sig, inf->code, (void __user *)addr,  
+		 fsr, 0);
+  
+  return 0;    
+}    
+
+
+  
+
+
+
+
 void __init
 hook_ifault_code(int nr, int (*fn)(unsigned long, unsigned int, struct pt_regs *),
 		 int sig, int code, const char *name)
diff --git a/arch/arm/mm/fsr-2level.c b/arch/arm/mm/fsr-2level.c
index a9f06f1..009b9c2 100644
--- a/arch/arm/mm/fsr-2level.c
+++ b/arch/arm/mm/fsr-2level.c
@@ -12,9 +12,9 @@
 	{ do_translation_fault,	SIGSEGV, SEGV_MAPERR,	"section translation fault"	   },
 	{ do_bad,		SIGBUS,	 0,		"external abort on linefetch"	   },
 	{ do_page_fault,	SIGSEGV, SEGV_MAPERR,	"page translation fault"	   },
-	{ do_bad,		SIGBUS,	 0,		"external abort on non-linefetch 1"  },
+	{ do_ignore,		SIGBUS,	 0,		"external abort on non-linefetch (Apollo-mod)"  },
 	{ do_bad,		SIGSEGV, SEGV_ACCERR,	"section domain fault"		   },
-	{ do_bad,		SIGBUS,	 0,		"external abort on non-linefetch 2"  },
+	{ do_bad,		SIGBUS,	 0,		"external abort on non-linefetch"  },
 	{ do_bad,		SIGSEGV, SEGV_ACCERR,	"page domain fault"		   },
 	{ do_bad,		SIGBUS,	 0,		"external abort on translation"	   },
 	{ do_sect_fault,	SIGSEGV, SEGV_ACCERR,	"section permission fault"	   },
@@ -52,7 +52,7 @@
 	{ do_translation_fault,	SIGSEGV, SEGV_MAPERR,	"section translation fault"	   },
 	{ do_bad,		SIGSEGV, SEGV_ACCERR,	"page access flag fault"	   },
 	{ do_page_fault,	SIGSEGV, SEGV_MAPERR,	"page translation fault"	   },
-	{ do_bad,		SIGBUS,	 0,		"external abort on non-linefetch 3"  },
+	{ do_bad,		SIGBUS,	 0,		"external abort on non-linefetch"  },
 	{ do_bad,		SIGSEGV, SEGV_ACCERR,	"section domain fault"		   },
 	{ do_bad,		SIGBUS,  0,		"unknown 10"			   },
 	{ do_bad,		SIGSEGV, SEGV_ACCERR,	"page domain fault"		   },
-- 
1.8.3.1

